#!/usr/bin/env python
import urllib2

# names of Tutorials
Tutorials = ('OutputData', \
'GroupAnalysis',
'QdecGroupAnalysis',
'AnatomicalROI',
'TroubleshootingData',
'MultiModalRegistration',
'MultiModalFmriIndividual',
'MultiModalFmriGroup',
'MultiModalDtiIndividual')

# prefixes and suffixes..
# ?action=raw gets the page in wiki format
pref = 'http://surfer.nmr.mgh.harvard.edu/fswiki/FsTutorial/'
post = '?action=raw'
cshhdr = '#! /bin/tcsh -f\nset echo\n'

# iterate through the names
for tutname in Tutorials:
    # get the whole page in data
    url = pref + tutname  + post
    print 'scraping', url
    usock = urllib2.urlopen(url)
    data = usock.read()
    # split it into a list with newline as delimiter
    itdata = data.split('\n')
    usock.close()
    
    # open cshfile for writing ( same name as the Tutorial page names )
    cshfile = open(tutname + '.csh', 'w')
    cshfile.write(cshhdr)
    
    # we need the commands between the following structure
    # ----
    # {{{
    # <command1>
    # <command2>
    # }}}
    # ----
    # following code gets us command1 and command2
    it = iter(itdata)
    while 1:
        try:
            if it.next().startswith('----'):
                if it.next().startswith('{{{'):
                    # we have a hit
                    command = it.next()
                    while not command.startswith('}}}'):
                        if not command.startswith('tcsh'): # don't need new shell
                            cshfile.write('\n')
                            cshfile.write(command.rstrip()) # don't need ascii 015
                        command = it.next()
                    cshfile.write('\n')
        except StopIteration:
            break
    cshfile.close()
